VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form Main 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Spark Fun Electronics - GM862 Take Photo!"
   ClientHeight    =   2235
   ClientLeft      =   1350
   ClientTop       =   2970
   ClientWidth     =   6195
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2235
   ScaleWidth      =   6195
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdTakePhoto 
      Caption         =   "&Take Photo!"
      Height          =   375
      Left            =   1440
      TabIndex        =   8
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton cmdBreak 
      Caption         =   "&Break"
      Height          =   375
      Left            =   2640
      TabIndex        =   7
      Top             =   360
      Width           =   1095
   End
   Begin VB.ComboBox cboCommPort 
      Height          =   315
      ItemData        =   "Main.frx":0ECA
      Left            =   3960
      List            =   "Main.frx":0EE9
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   360
      Width           =   1100
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   3840
      Top             =   1440
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      InBufferSize    =   4096
   End
   Begin MSComDlg.CommonDialog cd1 
      Left            =   4440
      Top             =   1560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblDownloadBarFG 
      BackColor       =   &H00800000&
      Height          =   255
      Left            =   840
      TabIndex        =   6
      Top             =   870
      Width           =   495
   End
   Begin VB.Label lblDownloadBarBG 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   840
      TabIndex        =   5
      Top             =   870
      Width           =   4695
   End
   Begin VB.Shape sptDownload 
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      Height          =   255
      Left            =   2400
      Shape           =   3  'Circle
      Top             =   8520
      Width           =   255
   End
   Begin VB.Label lblRetries 
      Caption         =   "Received Bytes:"
      Height          =   255
      Left            =   1200
      TabIndex        =   4
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label lblBytes 
      Caption         =   "0"
      Height          =   255
      Left            =   2520
      TabIndex        =   3
      Top             =   1680
      Width           =   1095
   End
   Begin VB.Label lblStatus 
      Caption         =   "Idle"
      Height          =   255
      Left            =   1800
      TabIndex        =   2
      Top             =   1320
      Width           =   3615
   End
   Begin VB.Label lblStat 
      Caption         =   "Status:"
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   1320
      Width           =   495
   End
   Begin VB.Menu File_Close 
      Caption         =   "&Exit"
   End
   Begin VB.Menu About_Menu 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Option Explicit

' 3-21-05 v1.0, Nathan Seidle, Created the basic JPEG reader for the GM862

Dim Stop_Waiting As Boolean
Dim CommPort As Integer

Private Sub About_Menu_Click()
    frmAbout.Show
End Sub

Private Sub cboCommPort_Click()
    CommPort = cboCommPort.ListIndex + 1
End Sub

Private Sub cmdBreak_Click()
    Stop_Waiting = True
End Sub

Private Sub cmdTakePhoto_Click()

    On Error GoTo Err_Handler
'Open port
'Open file to load JPG into
'Send camera commands, take photo, download to file

    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
    cmdBreak.Enabled = True
    
    'Open the port at 115200 - as required by the Telit Product Desctription page 227
    lblStatus.Caption = "Waking up GM862"
    MSComm1.CommPort = CommPort
    MSComm1.InputLen = 2
    MSComm1.InputMode = comInputModeText
    MSComm1.Settings = "115200,n,8,1"
    MSComm1.PortOpen = True
    
    'Wake up the GM862
    MSComm1.Output = "AT" & Chr(10) & Chr(13)
    
    'Wait for OK response
    Do While MSComm1.Input <> "OK"
        'See if user wants to stop
        If Stop_Waiting = True Then
            MsgBox "No response from GM862 - check that unit on turned on.", vbOKOnly
            GoTo GET_OUT
        End If
        
        DoEvents
    Loop
    
    lblStatus.Caption = "Turning on Camera"
    MSComm1.Output = "AT#CAMON" & Chr(10) & Chr(13)
    
    'Wait for OK response
    Do While MSComm1.Input <> "OK"
        
        If Stop_Waiting = True Then
            MsgBox "No response from GM862 - check that unit on turned on.", vbOKOnly
            GoTo GET_OUT
        End If
        
        DoEvents
    Loop
    
    lblStatus.Caption = "Taking photo!"
    MSComm1.Output = "AT#TPHOTO" & Chr(10) & Chr(13)
    
    'Wait for OK response
    Do While MSComm1.Input <> "OK"
        
        If Stop_Waiting = True Then
            MsgBox "No response from GM862 - check that unit on turned on.", vbOKOnly
            GoTo GET_OUT
        End If
        
        DoEvents
    Loop
    
    ' Create a file name with the current time attached
    file_name = FormatDateTime(Now(), vbLongTime)
    file_name = Replace(file_name, ":", "-")
    file_name = Replace(file_name, " PM", "")
    file_name = Replace(file_name, " AM", "")
    file_name = "c:\GM862_" & file_name & ".jpg"
    
    ' Delete any existing file that may have this name
    On Error Resume Next
    Kill file_name
    On Error GoTo Err_Handler

    'Set the input length very long and record incoming data to a binary file
    fnum = FreeFile()
    Open file_name For Binary As #fnum
    
    lblStatus.Caption = "Reading photo"
    MSComm1.InputLen = 1
    MSComm1.InputMode = comInputModeBinary
    MSComm1.Output = "AT#RPHOTO" & Chr(10) & Chr(13)
    
    Dim this_byte As Byte
    Dim last_byte(4) As Byte
    
    lblBytes = 0
    lblDownloadBarFG.Width = 0
    
    'Wait for OK response
    Do
        lblBytes = lblBytes + 1
        
        'Advance the status bar
        lblDownloadBarFG.Width = CInt((lblBytes * lblDownloadBarBG.Width) / 45000)
        
        'The GM862 can pause between pulses of ~1000bytes
        'We have to wait for it to continue transmitting
        Do While MSComm1.InBufferCount = 0
            DoEvents
        Loop
        
        last_byte(0) = last_byte(1)
        last_byte(1) = last_byte(2)
        last_byte(2) = last_byte(3)
        last_byte(3) = this_byte
        this_byte = AscB(MSComm1.Input)
        
        'Monster check for the 'OK', <CR> and <LF> at the end of the stream
        If last_byte(0) = AscB(Chr(10)) And _
           last_byte(1) = AscB("O") And _
           last_byte(2) = AscB("K") _
           And last_byte(3) = AscB(Chr(13)) Then Exit Do
        
        'Record to file
        Put #fnum, lblBytes, this_byte
        
        If Stop_Waiting = True Then
            MsgBox "Break during download - picture is probably toast.", vbOKOnly
            GoTo GET_OUT
        End If
        
        DoEvents
    Loop
    
    'Close the JPEG file
    Close #fnum
    
    lblDownloadBarFG.Width = lblDownloadBarBG.Width
    lblStatus.Caption = "All done!"
    
    MSComm1.PortOpen = False
    cmdBreak.Enabled = False

    Exit Sub
    
GET_OUT:
    lblStatus.Caption = "Ready"
    cmdBreak.Enabled = False
    Stop_Waiting = False
    MSComm1.PortOpen = False

    Exit Sub

Err_Handler:

    If Err.Number = 8002 Then
        MsgBox "Invalid port number : Please check your com setting and make sure the GM862 is attached."
    Else
        MsgBox "Error number : " & Err.Number
    End If
    
    Exit Sub

End Sub

Private Sub File_Close_Click()
    Unload Me
    End
End Sub

Private Sub Form_Load()

    lblDownloadBarFG.Width = 0
    
    cboCommPort.ListIndex = 2
    CommPort = cboCommPort.ListIndex + 1
    
    cmdBreak.Enabled = False
    
End Sub

